Subject: Re: can Git encrypt/decrypt .gpg on push/fetch?

From: Ted Zlatanov <[email-masked]>
Date: Fri, 09 Sep 2011 08:27:52 -0500

On Fri, 9 Sep 2011 16:20:10 +0530 Aneesh Bhasin <[email-masked]> wrote: 

AB> 2011/9/9 Ted Zlatanov <[email-masked]>
>> 
>> I need to store some encrypted files in Git but for some clients with
>> the right GPG keys, decrypt them on checkout (possibly also encrypt them
>> back on commit, but that's not as important).
>> 
>> diff doesn't have to work, this is just for convenience.  Can Git do
>> this (matching only .gpg files) or do I need my own command to run after
>> the checkout/fetch and before commit?  It seems pretty out of Git's
>> scope but perhaps others have done this before.
>> 

AB> Have you looked at git hooks (e.g. here : http://progit.org/book/ch7-3.html).

AB> You could do the encryption/decryption in pre-commit and post-checkout
AB> hooks scripts respectively...

Yes, thank you.  I was wondering if there could be further support so
they are checked out in a binary form on the server side if you don't
have the keys but in text form if you do.  So for instance "git log -p"
will DTRT on a client with the keys but not on a client without them.
This could require deep Git changes so I'm wondering if it's even
theoretically possible.

Thanks
Ted